from scipy.optimize import lsq_linear
import numpy

def calcul_surrogate(table,i,table2):
    
    plantBasedBiomass=0 
    treatedWood=0
    furnitureWood=1
    creosoteWood=0
    textiles=0
    paper=0
    plastics=0
    leather=0
    mixedWaste=0
    rubberWaste=0
    sludgeAndOrganic=0
    asphaltAndDist=0
    oil=0
    activatedCarbon=0
    tar=0
    diesel=0
    PEmodel=0
    PSmodel=0
    PPmodel=0
    PVCmodel=0
    PETmodel=0

    
    if not table.iloc[i][24] == 'NaN' or not table.iloc[i][24] == 'nan': #changed nan
        if '<' in str(table.iloc[i][24]):
            table.iloc[i][24]=table.loc[i][24].replace('<','')
            c = table.iloc[i][24]

            if ',' in table.iloc[i][24] :
                table.iloc[i][24]=table.loc[i][24].replace(',','.')
                c = float(table.iloc[i][24])
            c = float(table.iloc[i][24])

        else:

            c = float(table.iloc[i][24])    

    if not table.iloc[i][25] == 'NaN' or not table.iloc[i][25] == 'nan': #changed nan
        if '<' in str(table.iloc[i][25]):
            table.iloc[i][25]=table.iloc[i][25].replace('<','')
            h = table.iloc[i][25]
            if ',' in table.iloc[i][25] :
                table.iloc[i][25]=table.iloc[i][25].replace(',','.')
                h = float(table.loc[i][25])
            h = float(table.iloc[i][25])
        else:
            h = float(table.iloc[i][25])

    if not (table.iloc[i][26] == 'NaN' or table.iloc[i][16] == 'nan'): #changed nan
        if '<' in str(table.iloc[i][26]):
            table.iloc[i][26]=table.loc[i][26].replace('<','')
            o = table.ioc[i][26]
            if ',' in table.iloc[i][26] :
                table.iloc[i][26]=table.iloc[i][26].replace(',','.')
                o = float(table.iloc[i][26])
            o = float(table.iloc[i][26])
        else:
            o = float(table.iloc[i][26])

        
    if not table.iloc[i][27] == 'NaN' or not table.iloc[i][27] == 'nan': #changed nan
        if '<' in str(table.iloc[i][27]):
            table.loc[i][27]=table.iloc[i][27].replace('<','')
            n = table.iloc[i][27]
            if ',' in table.iloc[i][27] :
                table.iloc[i][27]=table.iloc[i][27].replace(',','.')
                n = float(table.iloc[i][27])
            n = float(table.iloc[i][27])
        else:
            n = float(table.iloc[i][27])
    

    if not (table.iloc[i][33]=='NaN' or table.iloc[i][33] == 'nan'): #changed nan
        if '<' in str(table.iloc[i][33]):
            table.iloc[i][33]=table.iloc[i][33].replace('<','')
            cl = float(table.loc[i][33]/10000)
            if ',' in table.iloc[i][33] :
                table.iloc[i][33]=table.iloc[i][33].replace(',','.')
        cl = float(table.iloc[i][33])/10000
    else :
        cl=0
            
    if not (table.iloc[i][28] == 'NaN' or table.iloc[i][28] == ' '): #changed nan
        if '<' in str(table.iloc[i][28]):
            table.iloc[i][28]=table.iloc[i][28].replace('<','')
            s = table.iloc[i][28]
            if ',' in table.iloc[i][28] :
                table.iloc[i][28]=table.iloc[i][28].replace(',','.')
                s = float(table.iloc[i][28])
            s = float(table.iloc[i][28])
        else:
            s = float(table.iloc[i][28])
    else:
         s=0

    ash = float(table.iloc[i][6])
    
    if not table.iloc[i][5] == 0:
        moisture = float(table.iloc[i][5])
    else :
        moisture = 0

    ninbio=0.7
        
    ''' Fixed properties '''
    #Think these were wrong, updated them, old values commented out
    #Use channiwala
    cell_hhv = 17.740 #17.52
    hce_hhv = 18.053 #16.63
    ligc_hhv = 28.229 #22.21
    ligh_hhv = 25.344 #22.21
    ligo_hhv = 22.124 #22.21
    protc_hhv =  29.079#24.2
    proth_hhv = 26.619
    proto_hhv = 16.799
    sugar_hhv = 14.044
    lipid_hhv = 39.284
    gnh3no_hhv = 19.680 #3.4013
    co2i_hhv = 2.009 #0.1423
    h2s_so2_ocs_hhv = 7.125 #2.697 
    pe_hhv  = 46.827
    ps_hhv = 41.330
    pvc_hhv = 17.922
    pa_hhv = 32.129
    pp_hhv = 46.746
    pet_hhv = 23.321
    nr_hhv = 44.665
    asph_hhv = 40.387

#Source: algae characterization and multistep pyrolysis mechanism, Chemical model for thermal treatment of sewage sludge
    cell_hco= [44.447, 	#C 
               6.217, 	#H
               49.337, 	#O
               0.0000, 	#N
               0.0000, 	#CL
               0.0000]  #S
    
    hce_hco = [45.457, 	#C 
               6.104, 	#H
               48.440, 	#O
               0.0000, 	#N
               0.0000, 	#CL
               0.0000]  #S
    
    ligc_hco = [69.758, #C 
              5.4640, 	#H
              24.778, 	#O
              0.0000, 	#N
              0.0000, 	#CL
              0.0000]   #S
    
    ligh_hco=[60.543, 	#C 
              6.467, 	#H
              32.991, 	#O
              0.0000, 	#N
              0.0000, 	#CL
              0.0000]   #S
    
    ligo_hco=[56.872, 	#C 
              5.250, 	#H
              37.878, 	#O
              0.0000, 	#N
              0.0000, 	#CL
              0.0000]   #S
        
    protc_hco=[69.673, 	#C 
               5.262, 	#H
               12.065, 	#O
               13.000, 	#N
               0.0000, 	#CL
               0.0000]  #S
    
    proth_hco=[51.571,  #C 
               9.738,  #H
               25.760,  #O
               12.930,  #N
               0.0000, 	#CL
               0.0000]  #S
    
    proto_hco=[38.921, 	#C 
               6.533,  #H
               41.475,  #O
               13.072, 	#N
               0.0000, 	#CL
               0.0000]  #S

    sugar_hco=[40.918, 	#C 
               4.579,  #H
               54.504,  #O
               0,       #N
               0.0000, 	#CL
               0.0000]  #S

    lipid_hco=[77.089, #C 
               11.501,  #H
               11.409,  #O
               0.000, 	#N
               0.000, 	#CL
               0.0000]  #S

    gnh3no_hco=[0.000, 	#C 
               17.756, 	#H
               0.0000, 	#O
               82.244, 	#N
               0.000, 	#CL
               0.000]   #S
    		   
    co2i_hco=[27.292, 	#C 
             0.0000, 	#H
             72.708, 	#O
             0.0000, 	#N
             0.0000, 	#CL
             0.0000]    #S
    
    g_h2s_so2_ocs_hco=[7.591, 	#C 
                       1.274, 	#H
                       30.335, 	#O
                       0.0000, 	#N
                       0.0000, 	#CL
                       60.799]  #S
    
    pe_hco=[85.628, 	#C 
            14.372, 	#H
            0.0000, 	#O
            0.0000, 	#N
            0.0000, 	#CL
            0.0000] 	#S
    
    ps_hco=[92.257, 	#C 
            7.7425, 	#H
            0.0000, 	#O
            0.0000, 	#N
            0.0000, 	#CL
            0.0000] 	#S
    
    pvc_hco=[38.436, 	#C 
             4.8385, 	#H
             0.0000, 	#O
             0.0000, 	#N
             56.726, 	#CL
             0.0000] 	#S
    
    pa_hco=[63.685, 	#C 
            9.7985, 	#H
            14.138, 	#O
            12.378, 	#N
            0.0000, 	#CL
            0.0000] 	#S
    
    pp_hco=[85.726, 	#C 
            14.274, 	#H
            0.00, 	#O
            0.00, 	#N
            0.00, 	#CL
            0.00] 	#S

    pet_hco=[62.502, 	#C 
            4.196, 	#H
            33.302, 	#O
            0.00, 	#N
            0.00, 	#CL
            0.00] 	#S
    
    nr_hco=[88.235, 	#C 
            11.765, 	#H
            0.00, 	#O
            0.00, 	#N
            0.00, 	#CL
            0.00] 	#S

    asph_hco=[87.404, 	#C 
            8.542, 	#H
            1.474, 	#O
            2.580, 	#N
            0.00, 	#CL
            0.00] 	#S
    ''' Calculation start here'''
    
    bio1 = []    
    for (xa, xb) in zip(cell_hco, hce_hco):
        bio1.append(0.6 * xa + 0.4 * xb)

    bio02 = []    
    for (xa, xb) in zip(ligc_hco, ligh_hco):
        bio02.append(0.2 * xa + 0.8 * xb)

    bio03 = []    
    for (xa, xb) in zip(ligc_hco, ligo_hco):
        bio03.append(0.2 * xa + 0.8 * xb)

    bio2 = []    
    for (xa, xb,xc) in zip(ligc_hco, ligh_hco, lipid_hco):
        bio2.append(0.16 * xa + 0.64 * xb + 0.2*xc)

    bio3 = []    
    for (xa, xb,xc) in zip(ligc_hco, ligo_hco, sugar_hco):
        bio3.append(0.16 * xa + 0.64 * xb + 0.2*xc)    

    bio4 = []    
    for (xa, xb) in zip(cell_hco, hce_hco):
        bio4.append(0.9 * xa + 0.1 * xb)

    bio5 = []    
    for (xa, xb) in zip(cell_hco, hce_hco):
        bio5.append(0.8 * xa + 0.2 * xb)

    bio6 = []    
    for (xa, xb) in zip(ligc_hco, ligo_hco):
        bio6.append(0.05 * xa + 0.95 * xb)

    bio7 = []    
    for (xa, xb) in zip(ligc_hco, ligo_hco):
        bio7.append(0.05 * xa + 0.95 * xb)

    bion = []    
    for (xa, xb) in zip(proth_hco, gnh3no_hco):
        bion.append(0.5 * xa + 0.5 * xb)

    plastic1 = []
    for (xa, xb) in zip(pe_hco, pp_hco):
        plastic1.append(0.8 * xa + 0.2 * xb)

    oil1 = []
    for (xa, xb) in zip(pe_hco, asph_hco):
        oil1.append(0.6 * xa + 0.4 * xb)

    oil2 = []
    for (xa, xb) in zip(pe_hco, asph_hco):
        oil2.append(0.95 * xa + 0.05 * xb)

    oil3 = []
    for (xa, xb) in zip(pe_hco, asph_hco):
        oil3.append(0.15 * xa + 0.85 * xb)
    
    if plantBasedBiomass == 1:
        y=[bio1,bio2,bio3,g_h2s_so2_ocs_hco, protc_hco, proth_hco, proto_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)       
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')
        
        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.16*x.x[1] + 0.16*x.x[2]
        ligh = 0.64*x.x[1]
        ligo = 0.64*x.x[2]
        proto = x.x[6]
        protc = x.x[4]
        proth = x.x[5]
        lipid = 0.2*x.x[1]
        sugar = 0.2*x.x[2]
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = x.x[3]
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif treatedWood == 1:
        y=[bio1, bio2, bio3, bion, g_h2s_so2_ocs_hco, pet_hco, pvc_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.16*x.x[1] + 0.16*x.x[2]
        ligh = 0.64*x.x[1]
        ligo = 0.64*x.x[2]
        proto = 0
        protc = 0
        proth = 0.5*x.x[3]
        lipid = 0.2*x.x[1]
        sugar = 0.2*x.x[2]
        gnh3no= 0.5*x.x[3]
        co2i= 0
        h2s_so2_ocs = x.x[4]
        pe = 0
        ps = 0
        pvc = x.x[6]
        pa = 0
        pp = 0
        pet = x.x[5]
        nr = 0
        asph = 0
    
    elif furnitureWood == 1:
        y=[bio1, bio2, bio3, bion, g_h2s_so2_ocs_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.16*x.x[1] + 0.16*x.x[2]
        ligh = 0.64*x.x[1]
        ligo = 0.64*x.x[2]
        proto = 0
        protc = 0
        proth = 0.5*x.x[3]
        lipid = 0.2*x.x[1]
        sugar = 0.2*x.x[2]
        gnh3no= 0.5*x.x[3]
        co2i= 0
        h2s_so2_ocs = x.x[4]
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif textiles == 1:
        y=[bio4, bio2, bio3, bion, g_h2s_so2_ocs_hco, pet_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = [1.0, 0.05, 0.05, 1.0, 1.0, 1.0]
        #ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.9*x.x[0]
        hce  = 0.1*x.x[0]
        ligc = 0.16*x.x[1] + 0.16*x.x[2]
        ligh = 0.64*x.x[1]
        ligo = 0.64*x.x[2]
        proto = 0
        protc = 0
        proth = 0.5*x.x[3]
        lipid = 0.2*x.x[1]
        sugar = 0.2*x.x[2]
        gnh3no= 0.5*x.x[3]
        co2i= 0
        h2s_so2_ocs = x.x[4]
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = x.x[5]
        nr = 0
        asph = 0

    elif creosoteWood == 1:
        y=[bio1, bio2, bio3, g_h2s_so2_ocs_hco, asph_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.16*x.x[1] + 0.16*x.x[2]
        ligh = 0.64*x.x[1]
        ligo = 0.64*x.x[2]
        proto = 0
        protc = 0
        proth = 0
        lipid = 0.2*x.x[1]
        sugar = 0.2*x.x[2]
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = x.x[3]
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = x.x[4]

    elif paper == 1:
        y=[bio5, bio02, bio03, g_h2s_so2_ocs_hco, gnh3no_hco, co2i_hco, pe_hco, pvc_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.8*x.x[0]
        hce  = 0.2*x.x[0]
        ligc = 0.2*x.x[1] + 0.2*x.x[2]
        ligh = 0.8*x.x[1]
        ligo = 0.8*x.x[2]
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[4]
        co2i= x.x[5]
        h2s_so2_ocs = x.x[3]
        pe = x.x[6]
        ps = 0
        pvc = x.x[7]
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif sludgeAndOrganic == 1:
        y=[bio1, bio6, bio7, g_h2s_so2_ocs_hco, gnh3no_hco, co2i_hco, pvc_hco, sugar_hco, lipid_hco, protc_hco,proto_hco, proth_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.05*x.x[1] + 0.05*x.x[2]
        ligh = 0.95*x.x[2]
        ligo = 0.95*x.x[1]
        proto = x.x[10]
        protc = x.x[9]
        proth = x.x[11]
        lipid = x.x[8]
        sugar = x.x[7]
        gnh3no= x.x[4]
        co2i= x.x[5]
        h2s_so2_ocs = x.x[3]
        pe = 0
        ps = 0
        pvc = x.x[6]
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif leather == 1:
        y=[g_h2s_so2_ocs_hco, gnh3no_hco, pvc_hco, lipid_hco, protc_hco,proto_hco, proth_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = x.x[5]
        protc = x.x[4]
        proth = x.x[6]
        lipid = x.x[3]
        sugar = 0
        gnh3no= x.x[1]
        co2i= 0
        h2s_so2_ocs = x.x[0]
        pe = 0
        ps = 0
        pvc = x.x[2]
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0
        
    elif mixedWaste == 1:
        y=[bio1, bio02, bio03, sugar_hco, lipid_hco, proto_hco, proth_hco, protc_hco, gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco,plastic1,ps_hco, pa_hco,pvc_hco,pet_hco, nr_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = [1,1,1,1,1,1,1,1,table.iloc[i][9]/100,1,table.iloc[i][9]/100,1,1,1,1,1,1]
        # ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0.6*x.x[0]
        hce  = 0.4*x.x[0]
        ligc = 0.2*x.x[1]+0.2*x.x[2]
        ligh = 0.8*x.x[1]
        ligo = 0.8*x.x[2]
        proto = x.x[5]
        protc = x.x[7]
        proth = x.x[6]
        lipid = x.x[4]
        sugar = x.x[3]
        gnh3no= x.x[8]
        co2i= x.x[10]
        h2s_so2_ocs = x.x[9]
        pe = 0.8*x.x[11]
        ps = x.x[12]
        pvc = x.x[14]
        pa = x.x[13]
        pp = 0.2*x.x[11]
        pet = x.x[15]
        nr = x.x[16]
        asph = 0

    elif rubberWaste == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, ps_hco, pa_hco,pvc_hco,pet_hco, nr_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0
        ps = x.x[3]
        pvc = x.x[5]
        pa = x.x[4]
        pp = 0
        pet = x.x[6]
        nr = x.x[7]
        asph = 0

    elif plastics == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, ps_hco, pa_hco,pvc_hco,pet_hco, plastic1]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = [table.iloc[i][9]/100, 1, table.iloc[i][9]/100, 1, 1, 1, 1, 1]
        # ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0.8*x.x[7]
        ps = x.x[3]
        pvc = x.x[5]
        pa = x.x[4]
        pp = 0.2*x.x[7]
        pet = x.x[6]
        nr = 0
        asph = 0

    elif asphaltAndDist == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, asph_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = x.x[3]

    elif oil == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, oil1]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0.6*x.x[3]
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0.4*x.x[3]

    elif diesel == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, oil2]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0.95*x.x[3]
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0.05*x.x[3]

    elif tar == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, oil3]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0.15*x.x[3]
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0.85*x.x[3]

    elif activatedCarbon == 1:
        y=[gnh3no_hco, g_h2s_so2_ocs_hco,co2i_hco, ps_hco,asph_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= x.x[0]
        co2i= x.x[2]
        h2s_so2_ocs = x.x[1]
        pe = 0
        ps = x.x[3]
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = x.x[4]

    elif PEmodel == 1:
        y=[pe_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = 0
        pe = x.x[0]
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif PSmodel == 1:
        y=[ps_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = 0
        pe = 0
        ps = x.x[0]
        pvc = 0
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif PPmodel == 1:
        y=[pp_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = 0
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = x.x[0]
        pet = 0
        nr = 0
        asph = 0

    elif PVCmodel == 1:
        y=[pvc_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = 0
        pe = 0
        ps = 0
        pvc = x.x[0]
        pa = 0
        pp = 0
        pet = 0
        nr = 0
        asph = 0

    elif PETmodel == 1:
        y=[pet_hco]
        y = numpy.array(y)
        y=y.transpose()
        d = [c,h,o,n,cl,s]
        d = numpy.array(d)     
        lb = 0.0
        lb = numpy.array(lb)
        ub = 1.0
        ub = numpy.array(ub)
        #x = lsqlin(Y,d,A,b,Aeq,beq,lb,ub);
        
        x = lsq_linear(y, d, bounds=(lb, ub), method='trf')

        cell = 0
        hce  = 0
        ligc = 0
        ligh = 0
        ligo = 0
        proto = 0
        protc = 0
        proth = 0
        lipid = 0
        sugar = 0
        gnh3no= 0
        co2i= 0
        h2s_so2_ocs = 0
        pe = 0
        ps = 0
        pvc = 0
        pa = 0
        pp = 0
        pet = x.x[0]
        nr = 0
        asph = 0

    if cell <= 1e-6:
        cell = 0.0
      
    if hce <= 1e-6:
        hce = 0.0
    
    if ligc <= 1e-6:
        ligc = 0.0
    
    if ligh <= 1e-6:
        ligh = 0.0
    
    if ligo <= 1e-6:
        ligo = 0.0
    
    if protc <= 1e-6:
        protc = 0.0

    if proth <= 1e-6:
        proth = 0.0

    if proto <= 1e-6:
        proto = 0.0
    
    if sugar <= 1e-6:
        sugar = 0.0

    if lipid <= 1e-6:
        lipid = 0.0        

    if gnh3no <= 1e-6:
        gnh3no = 0.0
    
    if co2i <= 1e-6:
        co2i = 0.0
    
    if h2s_so2_ocs <= 1e-6 :
        h2s_so2_ocs = 0.0
    
    if pe <= 1e-6:
        pe = 0.0
    
    if ps <= 1e-6:
        ps = 0.0
    
    if pvc <= 1e-6:
        pvc = 0.0
    
    if pa <= 1e-6:
        pa = 0.0
    
    if pp <= 1e-6 :
        pp = 0.0

    if pet <= 1e-6 :
        pet = 0.0

    if nr <= 1e-6 :
        nr = 0.0

    if asph <= 1e-6 :
        asph = 0.0

    Norm = cell+hce+ligc+ligh+ligo+protc+proto+proth+lipid+sugar+gnh3no+co2i+h2s_so2_ocs+pe+ps+pvc+pa+pp+pet+nr+asph

   # check = (ash/100)+(moisture/100)
    if Norm!=0:
        Biomass_frac = cell/Norm+hce/Norm+ligc/Norm+ligh/Norm+ligo/Norm+protc/Norm+proto/Norm+proth/Norm+lipid/Norm+sugar/Norm
        Inorganics_frac = gnh3no/Norm+co2i/Norm+h2s_so2_ocs/Norm
        Platics_frac = pe/Norm+ps/Norm+pvc/Norm+pa/Norm+pp/Norm+pet/Norm
        Hydrocarbons_frac = nr/Norm + asph/Norm
    else : 
        Biomass_frac=0
        Inorganics_frac=0
        Platics_frac=0
        Hydrocarbons_frac = 0
    
#change for plastic
    cell=(cell/Norm)*(1-ash/100-moisture/100)
    hce=(hce/Norm)*(1-ash/100-moisture/100)
    ligc=(ligc/Norm)*(1-ash/100-moisture/100)
    ligh=(ligh/Norm)*(1-ash/100-moisture/100)
    ligo=(ligo/Norm)*(1-ash/100-moisture/100)
    protc=(protc/Norm)*(1-ash/100-moisture/100)
    proth=(proth/Norm)*(1-ash/100-moisture/100)
    proto=(proto/Norm)*(1-ash/100-moisture/100)
    sugar=(sugar/Norm)*(1-ash/100-moisture/100)
    lipid=(lipid/Norm)*(1-ash/100-moisture/100)
    gnh3no=(gnh3no/Norm)*(1-ash/100-moisture/100)
    co2i=(co2i/Norm)*(1-ash/100-moisture/100)
    h2s_so2_ocs= (h2s_so2_ocs/Norm)*(1-ash/100-moisture/100)
    pe= (pe/Norm)*(1-ash/100-moisture/100)
    ps=(ps/Norm)*(1-ash/100-moisture/100)
    pvc=(pvc/Norm)*(1-ash/100-moisture/100)
    pa=(pa/Norm)*(1-ash/100-moisture/100)
    pp=(pp/Norm)*(1-ash/100-moisture/100)
    pet=(pet/Norm)*(1-ash/100-moisture/100)
    nr=(nr/Norm)*(1-ash/100-moisture/100)
    asph=(asph/Norm)*(1-ash/100-moisture/100)

    Norm = cell+hce+ligc+ligh+ligo+protc+proto+proth+sugar+lipid+gnh3no+co2i+h2s_so2_ocs+pe+ps+pvc+pa+pp+pet+nr+asph+(ash/100)+(moisture/100)

    #Add new surrogates
    c_surrogate =  cell*cell_hco[0]+hce*hce_hco[0]+ligc*ligc_hco[0]+ligh*ligh_hco[0]+ligo*ligo_hco[0]+protc*protc_hco[0]+proto*proto_hco[0]+proth*proth_hco[0]+sugar*sugar_hco[0]+lipid*lipid_hco[0]+gnh3no*gnh3no_hco[0]+co2i*co2i_hco[0]+h2s_so2_ocs*g_h2s_so2_ocs_hco[0]+pe*pe_hco[0]+ps*ps_hco[0]+pvc*pvc_hco[0]+pa*pa_hco[0]+pp*pp_hco[0]+pet*pet_hco[0]+nr*nr_hco[0]+asph*asph_hco[0]
    h_surrogate =  cell*cell_hco[1]+hce*hce_hco[1]+ligc*ligc_hco[1]+ligh*ligh_hco[1]+ligo*ligo_hco[1]+protc*protc_hco[1]+proto*proto_hco[1]+proth*proth_hco[1]+sugar*sugar_hco[1]+lipid*lipid_hco[1]+gnh3no*gnh3no_hco[1]+co2i*co2i_hco[1]+h2s_so2_ocs*g_h2s_so2_ocs_hco[1]+pe*pe_hco[1]+ps*ps_hco[1]+pvc*pvc_hco[1]+pa*pa_hco[1]+pp*pp_hco[1]+pet*pet_hco[1]+nr*nr_hco[1]+asph*asph_hco[1]
    o_surrogate =  cell*cell_hco[2]+hce*hce_hco[2]+ligc*ligc_hco[2]+ligh*ligh_hco[2]+ligo*ligo_hco[2]+protc*protc_hco[2]+proto*proto_hco[2]+proth*proth_hco[2]+sugar*sugar_hco[2]+lipid*lipid_hco[2]+gnh3no*gnh3no_hco[2]+co2i*co2i_hco[2]+h2s_so2_ocs*g_h2s_so2_ocs_hco[2]+pe*pe_hco[2]+ps*ps_hco[2]+pvc*pvc_hco[2]+pa*pa_hco[2]+pp*pp_hco[2]+pet*pet_hco[2]+nr*nr_hco[2]+asph*asph_hco[2]
    n_surrogate =  cell*cell_hco[3]+hce*hce_hco[3]+ligc*ligc_hco[3]+ligh*ligh_hco[3]+ligo*ligo_hco[3]+protc*protc_hco[3]+proto*proto_hco[3]+proth*proth_hco[3]+sugar*sugar_hco[3]+lipid*lipid_hco[3]+gnh3no*gnh3no_hco[3]+co2i*co2i_hco[3]+h2s_so2_ocs*g_h2s_so2_ocs_hco[3]+pe*pe_hco[3]+ps*ps_hco[3]+pvc*pvc_hco[3]+pa*pa_hco[3]+pp*pp_hco[3]+pet*pet_hco[3]+nr*nr_hco[3]+asph*asph_hco[3]
    cl_surrogate = cell*cell_hco[4]+hce*hce_hco[4]+ligc*ligc_hco[4]+ligh*ligh_hco[4]+ligo*ligo_hco[4]+protc*protc_hco[4]+proto*proto_hco[4]+proth*proth_hco[4]+sugar*sugar_hco[4]+lipid*lipid_hco[4]+gnh3no*gnh3no_hco[4]+co2i*co2i_hco[4]+h2s_so2_ocs*g_h2s_so2_ocs_hco[4]+pe*pe_hco[4]+ps*ps_hco[4]+pvc*pvc_hco[4]+pa*pa_hco[4]+pp*pp_hco[4]+pet*pet_hco[4]+nr*nr_hco[4]+asph*asph_hco[4]
    s_surrogate =  cell*cell_hco[5]+hce*hce_hco[5]+ligc*ligc_hco[5]+ligh*ligh_hco[5]+ligo*ligo_hco[5]+protc*protc_hco[5]+proto*proto_hco[5]+proth*proth_hco[5]+sugar*sugar_hco[5]+lipid*lipid_hco[5]+gnh3no*gnh3no_hco[5]+co2i*co2i_hco[5]+h2s_so2_ocs*g_h2s_so2_ocs_hco[5]+pe*pe_hco[5]+ps*ps_hco[5]+pvc*pvc_hco[5]+pa*pa_hco[5]+pp*pp_hco[5]+pet*pet_hco[5]+nr*nr_hco[5]+asph*asph_hco[5]
    
    #Add surrogates here
    Check_MassFracSum = cell+hce+ligc+ligh+ligo+protc+proth+proto+sugar+lipid+gnh3no+co2i+h2s_so2_ocs+pe+ps+pvc+pa+pp+pet+nr+asph+ash/100+moisture/100

    Biomass_frac = (cell+hce+ligc+ligh+ligo+protc+proth+proto+sugar+lipid)
    Inorganics_frac = (gnh3no+co2i+h2s_so2_ocs)
    Platics_frac = pe+ps+pvc+pa+pp+pet
    Hydrocarbons_frac = nr+asph
    
    hhv_Surrogate_dry = cell/(1-(ash/100)-(moisture/100))*cell_hhv+hce/((100-ash-moisture)/100)*hce_hhv+ligc/((100-ash-moisture)/100)*ligc_hhv+ligh/((100-ash-moisture)/100)*ligh_hhv \
    +ligo/((100-ash-moisture)/100)*ligo_hhv+protc/((100-ash-moisture)/100)*protc_hhv+proto/((100-ash-moisture)/100)*proto_hhv+proth/((100-ash-moisture)/100)*proth_hhv \
    +sugar/((100-ash-moisture)/100)*sugar_hhv+lipid/((100-ash-moisture)/100)*lipid_hhv+gnh3no/((100-ash-moisture)/100)*gnh3no_hhv+co2i/((100-ash-moisture)/100)*co2i_hhv+ \
    h2s_so2_ocs/((100-ash-moisture)/100)*h2s_so2_ocs_hhv+pe/((100-ash-moisture)/100)*pe_hhv+ps/((100-ash-moisture)/100)*ps_hhv+pvc/((100-ash-moisture)/100)*pvc_hhv+pa/((100-ash-moisture)/100)*pa_hhv \
    +pp/((100-ash-moisture)/100)*pp_hhv+pet/((100-ash-moisture)/100)*pet_hhv+nr/((100-ash-moisture)/100)*nr_hhv+asph/((100-ash-moisture)/100)*asph_hhv
  
    hhv_Surrogate = ((hhv_Surrogate_dry*(1-(ash/100)))*(1-(moisture/100)))


#Remove Norm
    if (Norm !=0):
        
        table2.loc[i][14]=cell*100
        table2.loc[i][15]=hce*100
        table2.loc[i][16]=ligc*100
        table2.loc[i][17]=ligh*100
        table2.loc[i][18]=ligo*100
        table2.loc[i][19]=protc*100
        table2.loc[i][20]=proth*100
        table2.loc[i][21]=proto*100
        table2.loc[i][22]=sugar*100
        table2.loc[i][23]=lipid*100     
        table2.loc[i][24]=gnh3no*100
        table2.loc[i][25]=co2i*100
        table2.loc[i][26]=h2s_so2_ocs*100
        table2.loc[i][27]=pe*100
        table2.loc[i][28]=ps*100
        table2.loc[i][29]=pvc*100
        table2.loc[i][30]=pa*100
        table2.loc[i][31]=pp*100
        table2.loc[i][32]=pet*100
        table2.loc[i][33]=nr*100
        table2.loc[i][34]=asph*100

    else :
        table2.loc[i][14]= 'nan' 
        table2.loc[i][15]= 'nan'
        table2.loc[i][16]= 'nan'
        table2.loc[i][17]= 'nan'
        table2.loc[i][18]= 'nan'
        table2.loc[i][19]= 'nan'
        table2.loc[i][20]=''
        table2.loc[i][21]=''
        table2.loc[i][22]=''
        table2.loc[i][23]=''         
        table2.loc[i][24]= 'nan'
        table2.loc[i][25]= 'nan'
        table2.loc[i][26]= 'nan'
        table2.loc[i][27]= 'nan'
        table2.loc[i][28]= 'nan'
        table2.loc[i][29]= 'nan'
        table2.loc[i][30]= 'nan'
        table2.loc[i][31]= 'nan'   
        table2.loc[i][32]= 'nan'
        table2.loc[i][33]= 'nan'
        table2.loc[i][34]= 'nan'  
        
    table2.loc[i][0]=((c_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][1]=((h_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][2]=((o_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][3]=((n_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][4]=((cl_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][5]=((s_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*(1-(ash/100)-(moisture/100)))*100
    table2.loc[i][6]=ash
    table2.loc[i][7]=moisture
    table2.loc[i][35]=moisture
    table2.loc[i][36]=ash
    table2.loc[i][37]=Biomass_frac
    table2.loc[i][38]=Inorganics_frac
    table2.loc[i][39]=Platics_frac
    table2.loc[i][40]=Hydrocarbons_frac
    table2.loc[i][41]=hhv_Surrogate_dry
    table2.loc[i][42]=hhv_Surrogate   
    
    if (c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate !=0):
        table2.loc[i][8]= (c_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
        table2.loc[i][9]= (h_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
        table2.loc[i][10]= (o_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
        table2.loc[i][11]= (n_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
        table2.loc[i][12]= (cl_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
        table2.loc[i][13]= (s_surrogate/(c_surrogate+h_surrogate+o_surrogate+n_surrogate+cl_surrogate+s_surrogate))*100
    else :
        table2.loc[i][8] = table2.iloc[i][9] = table2.iloc[i][10] = table2.iloc[i][11] = table2.iloc[i][12] = table2.iloc[i][13] =''
  



